## percona-server 8.1.0-1

=== debian/changelog ===
percona-server (8.1.0-1-1) unstable; urgency=medium

  * Update to new upstream release Percona Server 8.1.0-1-1

 -- Ubuntu <ubuntu@ip-10-199-1-51.eu-west-1.compute.internal>  Wed, 15 Nov 2023 09:12:48 +0000
